// Copyright 1996, Marimba Inc. All Rights Reserved.
// @(#)RectList.java, 1.1, 10/19/96

package marimba.gui;

import java.awt.*;

/**
 * A list of rectangles.
 *
 * @author	Arthur van Hoff
 * @version 	1.1, 10/19/96
 */
class RectList {
    int nrects;
    Rect rects[];

    void add(Rect r) {
	add(nrects, r);
    }

    void add(int i, Rect r) {
	if (rects == null) {
	    rects = new Rect[4];
	} else if (rects.length == nrects) {
	    Rect newrects[] = new Rect[Math.max(4, nrects*2)];
	    System.arraycopy(rects, 0, newrects, 0, nrects);
	    rects = newrects;
	}
	System.arraycopy(rects, i, rects, i+1, nrects++ - i);
	rects[i] = r;
    }

    void delete(int i) {
	System.arraycopy(rects, i+1, rects, i, --nrects - i);
	rects[nrects] = null;
    }

    void clear() {
	while (nrects > 0) {
	    rects[--nrects] = null;
	}
    }

    /**
     * For debugging.
     */
    void list() {
	for (int i = 0 ; i < nrects ; i++) {
	    System.out.println(i + " : " + rects[i]);
	}
    }
}
