// Copyright 1996, Marimba Inc. All Rights Reserved.
// @(#)WidgetConstants.java, 1.44, 01/09/97

package marimba.gui;

/**
 * Some generally useful constants used in widgets.
 *
 * @author	Arthur van Hoff
 * @version 	1.44, 01/09/97
 */
public interface WidgetConstants {
    // It is sad, but true...
    final static boolean PC = "x86".equals(System.getProperty("os.arch"));
    final static boolean NT = "Windows NT".equals(System.getProperty("os.name"));

    int DETACHED	= 10000;

    int REST_EVENT	= 3285283;
    int WAKE_EVENT	= 3285284;
    int PAGE_EVENT	= 3285285;

    int SOLID		= 0;
    int PATTERN		= 1;

    int OUTLINE		= 3;
    int RAISED		= 4;
    int LOWERED		= 5;
    int ROUNDED		= 6;
    int SQUARE		= 7;
    int INVISIBLE	= 8;
    int NONE		= 9;
    int CENTER		= 10;
    int LEFT		= 11;
    int RIGHT		= 12;
    int TOP		= 13;
    int BOTTOM		= 14;
    int SCALE		= 15;
    int TOPLEFT		= 16;
    int UP		= 17;
    int DOWN		= 18;
    int BLINK		= 19;

    int VERTICAL 	= 20;
    int HORIZONTAL      = 21;
    int DRAG      	= 22;

    int BOXED		= 23;
    int PLAIN		= 24;
    int UNDERLINE	= 25;
    int FILLED		= 26;

    int NEVER		= 30;
    int OPTIONAL	= 31;
    int ALWAYS		= 32;

    int PICTURE		= 33;
    int CHECK		= 34;
    int RADIO		= 35;

    int FILL		= 36;
    
    int ANYWHERE	= 37;
    int INSIDE		= 38;
    
    int CONTENT		= 39;
    int SCROLLBAR	= 40;
    int BUTTON		= 41;
    int PROPORTIONAL	= 42;
    int CHAR		= 43;
    int WORD		= 44;
    int TRUNCATE	= 45;
    int DIAGONAL	= 46;

    int PAGE_UP		= 47;
    int PAGE_DOWN	= 48;
    int ASCENDING	= 49;
    int DESCENDING	= 50;
    int BOTH		= 51;

    int RED		= 52;
    int GREEN		= 53;
    int BLUE		= 54;

    int EXCLUSIVE	= 55;
    int MULTIPLE	= 56;
}
